// $Id: bzv.js 4179 2011-02-04 14:34:25Z place $
// $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-9.8.0/html/static/bzv.js $
//
// Provide the XMLHttpRequest class for IE 5.x-6.x:
// RESOURCE = http://en.wikipedia.org/wiki/XMLHttpRequest
// More information from http://www.w3.org/TR/XMLHttpRequest/

function trim(string){
    return YAHOO.lang.trim(string)
}

function makeArray(arrayName){
    if (this.container[arrayName] == null)
		this.container[arrayName] = new Array();
    return this.container[arrayName];
}

function HashContainer(){
    this.container = [];
    this.make = makeArray;
}

if(typeof XMLHttpRequest == "undefined") XMLHttpRequest = function() {
	try { return new ActiveXObject("Msxml2.XMLHTTP.6.0") } catch(e) {}
	try { return new ActiveXObject("Msxml2.XMLHTTP.3.0") } catch(e) {}
	try { return new ActiveXObject("Msxml2.XMLHTTP") } catch(e) {}
	try { return new ActiveXObject("Microsoft.XMLHTTP") } catch(e) {}
	throw new Error("This browser does not support XMLHttpRequest.")
};

// N.B. Configuration is generated in pageheader.sf
function readSysconfig(javaConfig){
    var decoded = Base64.decode (javaConfig);
    var sysconfig = '';
    sysconfig = YAHOO.lang.JSON.parse(decoded);
    return sysconfig
}

function onLoad(javaConfig){
    initFocus();

    YAHOO.util.Event.onDOMReady(function () {
		var userFeedbackNodes = YAHOO.util.Dom.getElementsByClassName('userFeedback');
		var userFeedbackLocation = document.getElementById ('searchTips');

		//  FIXME, dit werkt niet goed voor IE, daar zullen we wel innerhtml voor moeten gebruiken of zo.
		//  Het basisidee werkt wel: zet foutmeldingen voortaan op één vaste plek op het scherm.

		/*
		  for (var i = 0; i < userFeedbackNodes.length; i ++){
	      var firstChild = userFeedbackLocation.firstChild;

	      var text = userFeedbackNodes.innerHTML;
	      var cloned = document.createElement("div");

	      var li = document.createElement("li");
	      YAHOO.util.Dom.addClass(cloned,"userFeedback");

	      li.appendChild(cloned);
	      YAHOO.util.Dom.insertBefore(li, firstChild);
		  }
		*/
        for (var i = 0; i < userFeedbackNodes.length; i ++){
            var firstChild = userFeedbackLocation.firstChild;

            var cloned = clone(userFeedbackNodes[ i ]);
            var li = document.createElement("li");
            cloned.setAttribute("style","display:block");

            li.appendChild(cloned);
            YAHOO.util.Dom.insertBefore(li, firstChild);
        }
    });

}

function initFocus(){
    var el = document.getElementById('searchQuery');
    if (typeof(el) != "undefined")
		if (el) el.focus();
}

function submitExport(baseurl){
    var form = document.forms["download"];
    var query = "";
    var recordIds = form["recordId"];
    var first = true;
    for (var i = 0; i < recordIds.length; i++){
        if (recordIds[i].checked == true){
            if (!first) query += " or ";
            first = false;
            query += recordIds[i].value;
        }
    }
    form.elements["query"].value = query;
    baseurl = form["baseurl"].value;
    form.submit();
}

function checkAll(theElement) {
    var form = theElement.form;
    for(var i = 0; i < form.length; i++){
        if(form[i].type == 'checkbox' && form[i].name != 'all'){
            form[i].checked = theElement.checked;
        }
    }
}

function extractData(record) {
    var data = new Object();
    var fields = record.childNodes;
    var numFields = fields.length;
    for(var j = 0; j < numFields; j++) {
        var field = fields[j];
        if(!field.tagName) continue;
        if(field.childNodes && field.childNodes[0])
            data[field.tagName] = field.childNodes[0].nodeValue;
    }
    return data;
}

function containsYear(text){
    return text.match("^[0-9]{4}$")             ||
           text.match("\([0-9]{4}[-)])")        ||
           text.match("[0-9a-zA-Z]+ [0-9]{4}");
}

function isVolume(text, year, volume){
    if (text.match("^" + year)             ||
        //er komt iets voor het jaar, bijv. REG 
        text.match("[0-9a-zA-Z]+ " + year)    ||
        text.match("[ ,-]" + volume + "$") ||
        text.match(" " + volume + "[,-]")  ||
        text.match("^" + volume + "$")     ||
        text.match("^" + volume + "[,-]")) return true
    var prevYear = year - 1;
    var target = prevYear + "[-/]" + year.substring(2);
    return text.match("^" + target)        ||
           //er komt iets voor het jaar, bijv. REG 
           text.match("[0-9a-zA-Z]+ " + target);      
}

function ophaaltype(callNumber, date){
    for (var i in cf.ophaalRules){
        var rule = cf.ophaalRules[i];
        var split = rule.split("|");
        //  matches(condition, observation)
        if (matches(split[0], date)){
            if (matches(split[1], callNumber)){
                return trim(split[3]);
            } // 1 callNumber
        } // 0 date
    } // for uitleenRules
    return "";
}

function createLinkDiv(url, displayText, windowsTitle, loanDeskBoolean, imageBoolean){
    var divNode = document.createElement("div");
    if (imageBoolean){
	    var imageNode = document.createElement("img");
	    var file = document.location.protocol + "//" + document.location.hostname + "/files/edoc.gif";
	    imageNode.setAttribute("src", file);
	    imageNode.setAttribute("alt", "*");
	    divNode.appendChild(imageNode);
    }

    var linkNode = document.createElement("a");
    if (loanDeskBoolean){
        /* loandesk link */
        divNode.onclick = function(){
            window.open(url, 'Loandesk', 'scrollbars=yes,toolbar=no,location=no,directories=no,status=no,menubar=no,copyhistory=no')
        }
        linkNode.setAttribute("href", "javascript:");
        linkNode.setAttribute("title", windowsTitle);
    }
    else {
        /* full text link */
        linkNode.setAttribute("href", url);
        linkNode.setAttribute("target", "_blank");
    }
    var textNode = document.createTextNode(displayText);
    linkNode.appendChild(textNode);
    divNode.appendChild(linkNode);
    return divNode;
}

function createDepotRequest(location, epn, volumeId, ophaaltype, displayText) {
    var title = translate("hoverTextOrder")
    var url = cf.loandeskBaseUrl + "/order?epn=" + epn;
    if (volumeId) url = url + "&volumeid=" + volumeId;
    if (ophaaltype) url += "&ophaaltype=" + ophaaltype;
    return createLinkDiv(url, displayText, title, true, false);
}

function createReserveRequest(location, epn, volumeId, nofr, da, displayText) {
    var title = translate("hoverTextReserve")
    var url = cf.loandeskBaseUrl + "/reserve?epn=" + epn;
    if (volumeId) url = url + "&volumeid=" + volumeId;
    if (nofr) url = url + "&reservation=" + nofr.replace(/^\s+/, '');
    if (da) url = url + "&returndate=" + da;
    return createLinkDiv(url, displayText, title, true, false, false);
}

function createFreeRequest(location, epn, metadata, ophaaltype, displayText) {
    var title = translate("hoverTextFreeOrder")
    var url = cf.loandeskBaseUrl + "/free?epn=" + epn;
    if (metadata["date"]) url += "&year=" + metadata["date"];
    if (metadata["volume"]) url += "&volume=" + metadata["volume"];
    if (metadata["issue"]) url += "&issue=" + metadata["issue"];
    if (ophaaltype) url += "&ophaaltype=" + ophaaltype;
    return createLinkDiv(url, displayText, title, true, false, false);
}

function translate(key) {
    if (key == null) return '';

    var value =  cf.translateHash[key.toLowerCase()];
    if (!value) value = key;

    return value;
}

function processLocatorInfo(o, metadata, nodeHash){
    var rootNode = o.responseXML.documentElement;
    var records = rootNode.childNodes;
    var numRecords = records.length;
    for(var i = 0; i < numRecords; i++) {
        var record = records[i];
        if(!record.tagName || record.tagName != 'record') continue;
        processRecordWithLocatorInfo(record, metadata, nodeHash);
    }
}

function processRecordWithLocatorInfo(record, metadata, nodeHash ){
    var loanDeskBoolean = false;
    var emphasis = false;
    var locInfo = extractData(record);
    var url = locInfo.generatedUrl;
    var title = "";

    if (url && url.indexOf('://') != -1){
        var image = true;
        var group = "linkmethod";
        if (locInfo.linkMethod == 'ILL'){
            image = false;
            group = "ill";
        }

        var linkText = ""
        if (group == "linkmethod") linkText = locInfo.methodName?locInfo.methodName:locInfo.linkTitle;
        else if (group == "ill") linkText = cf.availDisplayText['requestdoc']
        nodeHash.make(group).push(createLinkDiv(url, linkText, title, loanDeskBoolean, image, emphasis));
    }
    else {
        if (locInfo.callNumber){
            if (metadata["genre"] == "article"){
                if (locInfo.action == "stack"){
                    var callNumber = locInfo.callNumber;
                    var text = callNumber;
                    if (callNumber.indexOf('T ') == 0 || callNumber.indexOf('TF ') == 0){
                        // this test is to filter non-journals; however there are call number for books that start with "TF "
                        // this problem will be solved when full-journal-title searching is implemented
                        text += " (" + locInfo.collection + ")";
                    }
                    nodeHash.make('inlibrary').push(document.createTextNode(text));
                    return;
                }
            }
            processRecordWithCirculationInfo(record, metadata, nodeHash);
        }
    }
}

function matches(condition, observation){
    var cond = trim(condition);
    if (!cond) return true;
    if (cond.substr(0,1) == '<'){
        if (parseInt(observation) < parseInt(cond.substr(1))) return true;
    }
    if (cond.substr(0,1) == '>'){
        return true;
        if (parseInt(observation) > parseInt(cond.substr(1))) return true;
    }
    if (cond.substr(0,3) == 'NOT'){
        if (observation != cond.substr(4)) return true;
    }
    if (cond.substr(0,8) == 'CONTAINS'){
        if (observation.indexOf(cond.substr(9)) > -1) return true;
    }
    if (cond.indexOf('*') > 0){
        var loc = cond.indexOf('*') - 1;
        if (observation.substring(0, loc) == cond.substring(0, loc)) return true;
    }
    if (observation == cond) return true;
    else return false;
}

function getDLFElements(element, tagName){
    var elements = element.getElementsByTagName("dlf:" + tagName);
    if (elements.length > 0) return elements;
    try { 
        return element.getElementsByTagNameNS("http://diglib.org/ilsdi/1.1", tagName);
    }
    catch(e){
        return null;
    }
}   

function displayVolume(numVolumes, metadata, volumeText){
    var genre = metadata["genre"];
    if (numVolumes > 0 && genre != "journal" && genre != "series" ) {
        var year  = metadata["date"];
        var volume = metadata["volume"];
        if (genre == "article" || containsYear(volumeText)){
            if (!isVolume(volumeText, year, volume)) return false;
        }
    }
    return true;
}

function processRecordWithCirculationInfo(record, metadata, nodeHash, actions){
    var locInfo = extractData(record);
    var status = locInfo.status;
    // e-book
    if (status == 'e') return;
    var genre =  metadata["genre"];
    var callNumber = locInfo.callNumber;
    if (!actions || !actions[callNumber] || genre == "journal") var action = locInfo.action;
    else var action = actions[callNumber];
    var epn = locInfo.epn;
    var loanDeskBoolean = false;
    var title = "";

    var volumes = getDLFElements(record, "record");
    if (volumes){
        var numVolumes = volumes.length;
        for(var i = 0; i < numVolumes; i++) {
            var volume = volumes[i];
            var availStatus = getDLFElements(volume, "availabilitystatus");
            if (availStatus && availStatus.length > 0){
                var availability = availStatus[0].childNodes[0].nodeValue;
                var availabilitymsg = "";
                var availmsg = getDLFElements(volume, "availabilitymsg");
                if (availmsg && availmsg.length > 0 && availmsg[0].childNodes.length > 0) availabilitymsg = availmsg[0].childNodes[0].nodeValue;
                var matchingRuleExists = false;
                for (var r in cf.availabilityRules){
                    var rule = cf.availabilityRules[r];
                    var split = rule.split("|");
                    //  matches(condition, observation)
                    if (matches(split[0], availability)){
                        if (matches(split[1], action)){
                            if (matches(split[2], availabilitymsg)){
                                if (matches(split[3], status)){
                                    var label       = trim(split[5]);
                                    var request     = trim(split[6]);
                                    var displayText = trim(split[7]);

                                    var text = callNumber.replace('...', '');
                                    var volumeText = "";
                                    if (displayText == 'vol' || displayText== 'kort' || displayText == 'volNot'){
                                        var volumeinfo = getDLFElements(volume, "volumeinfo");
                                        if (volumeinfo && volumeinfo.length > 0 && volumeinfo[0].childNodes.length > 0) {
                                            volumeText = volumeinfo[0].childNodes[0].nodeValue;
                                            text += " (" + volumeText;
                                            if (displayText == 'kort') text += "; " + cf.availDisplayText['kortUitleenbaar'];
                                            else if (displayText == 'volNot') text += "; " + cf.availDisplayText['notforloan'];
                                            text += ")";
                                        }
                                        else {
                                            if (displayText == 'volNot') text += " (" + cf.availDisplayText['notforloan'] + ")";
                                        }
                                    }
                                    if (displayText == 'not') text += " (" + cf.availDisplayText['notforloan'] + ")";

                                    var volumeId = "";
                                    var identifier = getDLFElements(volume, "identifier");
                                    if (identifier && identifier.length > 0)   
                                        volumeId = identifier[0].childNodes[0].nodeValue;
                                   
                                    switch(request){
                                        case "order":
                                            var ophtype = ophaaltype(callNumber, metadata["date"]);
                                            if (displayVolume(numVolumes, metadata, volumeText))
                                                nodeHash.make(label).push(createDepotRequest(callNumber, epn, volumeId, ophtype, text));
                                            break;
                                        case "reserve":
                                            var dateavail = getDLFElements(volume, "dateavailable");
                                            var da = '';
                                            if (dateavail && dateavail.length > 0 && dateavail[0].childNodes.length > 0)
                                                da = dateavail[0].childNodes[0].nodeValue;
                                            var nofreservations = getDLFElements(volume, "numberofreservations");
                                            var nofr = ''
                                            if (nofreservations && nofreservations.length > 0 && nofreservations[0].childNodes.length > 0)
                                                nofr = nofreservations[0].childNodes[0].nodeValue;
                                            if (nofr == 4) {
                                                label = "onloannoreserv";
                                                text += " " + cf.availDisplayText['reservationnotpossible'];
                                                nodeHash.make(label).push(document.createTextNode(text));
                                            }
                                            else{
                                                if (da) text += " (" +  cf.availDisplayText['onloanuntil'] + " " + da;
                                                if (nofr){
                                                    if (!da) text += " (";
                                                    else text += ", ";
                                                    text += nofr + " " +  cf.availDisplayText['reservations'];
                                                }
                                                if (da || nofr) text += ")"
                                                if (displayVolume(numVolumes, metadata, volumeText))
                                                    nodeHash.make(label).push(createReserveRequest(callNumber, epn, volumeId, nofr, da, text));
                                            }
                                            break;
                                        case "free":
                                            var ophtype = ophaaltype(callNumber, metadata["date"]);
                                            nodeHash.make(label).push(createFreeRequest(callNumber, epn, metadata, ophtype, text));
                                            break;
                                        default:
                                            if (displayVolume(numVolumes, metadata, volumeText))
                                                nodeHash.make(label).push(document.createTextNode(text));
                                    }
                                    matchingRuleExists = true;
                                    break;
                                } // 3 status
                            } // 2 availabilitymsg
                        } // 1 action
                    } // 0 availability
                } // for availabilityRules 
                if (matchingRuleExists == false) nodeHash.make('problem').push(document.createTextNode('no decision rule'));
            } // if availStatus.length > 0
        } // for
    } // if (volumes)
    // epn, but no availability info
    else if (epn){
        url = "search?displayType=single&query=mods.location.holdingSimple.copyInformation.note=" + epn
        nodeHash.make('moreinfo').push(createLinkDiv(url, callNumber, title, loanDeskBoolean, false, false));
    }
    else if (locInfo.linkMethod = 'ILL')
        nodeHash.make('ill').push(createLinkDiv(locInfo.generatedUrl, cf.availDisplayText['requestdoc'], title, loanDeskBoolean, false, false));
}

function processCirculationInfo(o, metadata, nodeHash, actions ){
	var rootNode = o.responseXML.documentElement;
	var records = rootNode.childNodes;
	var numRecords = records.length;
	for(var i = 0; i < numRecords; i++) {
		var record = records[i];
		if (record.tagName && record.tagName == 'record')
			processRecordWithCirculationInfo(record, metadata, nodeHash, actions );
	}
}

function presentAvailability(node, o, openurl, location) {
    var query  = openurl.split("?")[1];
    var pairs  = query.split("&");
    var metadata = [];
    for (var i=0; i < pairs.length; i++) {
        var pair = pairs[i].split("=");
        switch (pair[0]){
            case "genre":
                metadata["genre"] = pair[1]
                break;
            case "date":
                metadata["date"] = pair[1]
                break;
            //FIXME year wordt doorgeven als locator niet goed overweg kan met date.
            case "year":
                metadata["date"] = pair[1]
                break;
            case "volume":
                metadata["volume"] = pair[1]
                break;
            case "issue":
                metadata["issue"] = pair[1]
        }
    }

    var nodeHash = new HashContainer();

    if (!location){
        processLocatorInfo(o, metadata, nodeHash);
    }
    //FIXME actions komen van bzv server;
    //eigenlijk moeten deze geleverd worden door locator
    //locator doet dat op dit moment niet optimaal
    else {
        var pairs   = location.split(";");
        var actions = [];
        for (var i=0; i < pairs.length; i++){
            var pair = pairs[i].split("=");
            actions[pair[0]] = pair[1];
        }
        processCirculationInfo(o, metadata , nodeHash, actions);
    }

    for (var group in cf.availabilityGroups ){

        if (nodeHash.container[group] != null){
            var titleNode = document.createElement("li");
            YAHOO.util.Dom.addClass(titleNode, "title");
            titleNode.appendChild(document.createTextNode(cf.availabilityGroups[group]));
            node.appendChild(titleNode);

            for (var link in nodeHash.container[group]){
                var liNode = document.createElement("li");
                liNode.appendChild(nodeHash.container[group][link]);
                node.appendChild(liNode);
	        }
        }
    }
}

function fixXml4Chrome(o){
    if ((o.responseXML == null) && (o.responseText.length > 0))  {
		var parser=new DOMParser();
		var responseXML = parser.parseFromString(o.responseText,"text/xml");
		o.responseXML = responseXML;
    }
}

function resolver(nodeId, openURL, linkIcon, linkText){
    var node = document.getElementById(nodeId);
    var divNode = document.createElement("div");
        
    var linkNode = document.createElement("a");
    linkNode.setAttribute("href", openURL);
    linkNode.setAttribute("target", "_blank");
    if (linkIcon){
        var imageNode = document.createElement("img");
        imageNode.setAttribute("src", linkIcon);
        imageNode.setAttribute("alt", linkText);
        linkNode.appendChild(imageNode);
    }
    else{
        var textNode = document.createTextNode(linkText);
        linkNode.appendChild(textNode);
    }
    divNode.appendChild(linkNode);
        
    node.appendChild(divNode);
}

function openurl(nodeid, location, openurl){
    var node = document.getElementById(nodeid);

    function successHandler(o) {
		fixXml4Chrome(o);
		presentAvailability(node, o, openurl, location);
    }

    function failureHandler(o)
    {
		/*
		  if (console)
	      console.error('Meresco:openurl XMLHttpRequest statusText: ' + o.statusText);
		*/
		node.appendChild(document.createTextNode("Locator unavailable or not responding in time"));
    }

    var request = YAHOO.util.Connect.asyncRequest('GET', openurl, {
	    success:successHandler,
	    failure:failureHandler,
	    timeout: 25000
	});
}

// searchForm stuff
function relocateKeepDrilldown(drilldown){
    var searchQuery = document.getElementById('searchQuery');

    var extra='';
    if (location.pathname == '/'){
		extra = 'search';
    }
    var newLocation = extra + "?query=" + encodeURIComponent(searchQuery.value);

    if (drilldown){
		newLocation += drilldown;
    }

    var sortKeys = document.getElementById('sortKeys');
	newLocation += "&sortKeys=" + sortKeys.value;

    top.location = newLocation;
    return false;
}

function relocateKeepQuery(obj){
    var searchQuery = getElementById('searchQuery');
    var newQuery = "?query=" + encodeURIComponent(searchQuery.value);
    var newLocation = newQuery + '&' + obj.value ;
    top.location= newLocation;
}

function relocateKeepQueryHref(query){
    var searchQuery = document.getElementById('searchQuery');
    var newQuery = "?query=" + encodeURIComponent(searchQuery.value);
    var newLocation = newQuery + '&' + query
    top.location= newLocation;
    return false;
}

function clearSearch(){
    var l=top.location;
    var port=l.port;
    if (l.port)
		port=":"+port;

    top.location=l.protocol + "//" + l.hostname + port + "/search?query=";
}

// YAHOO stuff
modules  = new Array();

function clone(node) {

    var tagName = node.tagName;
    var nodeValue = node.nodeValue;

    if(tagName) {
		var cln = document.createElement(tagName);

		var att = node.attributes;
		for(var i = 0; i < att.length; i++){
			if (att[i].name == 'class')
				YAHOO.util.Dom.addClass(cln, att[i].value);
			else
				cln.setAttribute(att[i].name, att[i].value);
		}

		var chi = node.childNodes;
		for(var i = 0; i < chi.length; i++)
			cln.appendChild(clone(chi[i]));

		return cln;
    } else if(nodeValue) {
		return document.createTextNode(nodeValue);
    }
}

function extractRecord(xmlDoc) {
    var rootNode = xmlDoc.documentElement;

    if(rootNode.nodeName=='parsererror') {
		//if (console)
		//    console.error(rootNode.firstChild.nodeValue);
    }

    var data = new Array();
    var fields = rootNode.childNodes;

    for(var i = 0; i < fields.length; i++) {
        var field = fields[i];

        if(!field.tagName || field.tagName != 'field')
            continue;

		var datum = new Object();

        var fieldElements = field.childNodes;
        for(var j = 0; j < fieldElements.length; j++) {
            var fieldElement = fieldElements[j];
			var tagName = fieldElement.tagName;

			if(!tagName)
                continue;

            if(tagName == 'label')
				datum.label = fieldElement.childNodes[0].nodeValue;
			else
				datum.content = fieldElement;
        }
		data.push(datum);
    }
    return data;
}

function presentData(dataArray, widget, index) {
    var tableNode = document.getElementById('table'+index);
    // Cleanup previous results
    while (tableNode.firstChild) {
		tableNode.removeChild(tableNode.firstChild);
    }

    // DO NOT use e.setAttribute("class", "classname");
    // because IE will ignore the call completely.
    // In stead use:
    // YAHOO.util.Dom.addClass(tableNode, "recordElementTable");
    // For IE 'tbody' is required
    // IE needs tr and td elements mere divs are invisible
    //
    //var tBodyNode  = document.createElement('tbody');
    //YAHOO.util.Dom.addClass(tBodyNode, "recordElementTableBody");
    var collect='';

    for(var i = 0; i < dataArray.length ; i++) {
        var field =              dataArray[i];
        var rowNode =            document.createElement('div');

		var className = field.label;
		className = className.replace(/[\s\W]*/g,"");

		YAHOO.util.Dom.addClass(rowNode, className);

		var thLabelNode = document.createElement('div');
		YAHOO.util.Dom.addClass(thLabelNode, "label");

		var tdContentNode = document.createElement('div');
		YAHOO.util.Dom.addClass(tdContentNode,"value");
		//console.log("label: " + field.label)


		var trLabel = translate(field.label)
		thLabelNode.appendChild(document.createTextNode(trLabel));
		rowNode.appendChild(thLabelNode);

		var childNodes = field.content.childNodes;
		for(var j = 0; j < childNodes.length; j++) {

			if(childNodes[j]) {
				var chi = clone(childNodes[j]);
				tdContentNode.appendChild(chi);
			}
		}
		rowNode.appendChild(tdContentNode);
		//tBodyNode.appendChild(rowNode);
		//tableNode.appendChild(tBodyNode);
		tableNode.appendChild(rowNode);
    }
}


function getContent(widget,recordId,index,context)
{
    function successHandler(o) {
		fixXml4Chrome(o);
        var data = extractRecord(o.responseXML);
        presentData(data, widget, index);
    }

    function failureHandler(o) {
        var widgetNode=document.getElementById("content"+index);
        YAHOO.util.Dom.addClass(widgetNode,"recordElementContentError");
        if(o.status == 403)
            widget.setBody("Access denied. Are you logged in?");
        else
            widget.setBody("Record information could not be retrieved: "+o.statusText+" ("+o.status+")");

		widget.render();

    }

    var request = YAHOO.util.Connect.asyncRequest('GET',"/record?recordId="+recordId+"&context="+context, {
        success:successHandler,
        failure:failureHandler,
        timeout: 15000
    });
}

function singleRecordDetails(index, recordId, context){
    YAHOO.util.Event.onDOMReady(function () {
        modules[index]=new Array();
        modules[index].widget=new YAHOO.widget.Module("content"+index, { visible: true });

        getContent(modules[index].widget,recordId,index,context);
        modules[index].widget.render();
	});
}

function generateMoreinfoToggler(index, buttonPreName, recordId){
    var more = translate("showDetails");
    var less = translate("hideDetails");

    YAHOO.util.Event.onDOMReady(function () {
        modules[index]=new Array();
        modules[index].button =
            new YAHOO.widget.Button({ type: "checkbox",
									  label: more,
									  id: "checkbutton"+index, name: "checkboxfield"+index,
									  value: "1",
									  container: "moduleContainer"+index, checked: false });

	    modules[index].button.set('class','button');
        modules[index].widget=new YAHOO.widget.Module("content"+index, { visible: false });
        modules[index].widget.render();

        function onCheckedChange(e) {
            if (e.newValue) {
                modules[index].button.set('label',less);
                getContent(modules[index].widget,recordId,index, "normal");
                modules[index].widget.show();
            } else {
                modules[index].widget.hide();
                modules[index].button.set('label',more);
            }
            modules[index].widget.render();
        }
        modules[index].button.addListener("checkedChange", onCheckedChange);

	});
}

// errorImg MUST meet the specified criteria to prevent eternal loop
function onImageLoaded(img, errorImg)
{
    if ( img.naturalWidth < cf.minCoverWidth ){
		img.src = errorImg;
    }
    return true;
}

// errorImg MUST ALWAYS BE PRESENT to prevent eternal loop
function onImageError(img, errorImg)
{

	// This works in Chrome only :)
    var parentNode = img.parentNode;
    var grandParentNode = parentNode.parentNode;
    grandParentNode.appendChild(img);
    grandParentNode.removeChild(parentNode);

    img.src = errorImg;
    return true;
}

function morelessFacets(moreless, label){
    var hide = 'chopped-';
    var show = 'full-';
    if (moreless == translate('less')){
		hide = 'full-';
		show = 'chopped-'
    }
    var obj  =  widgetNode=document.getElementById(hide + label);
    obj.style.display='none';
    obj  =  widgetNode=document.getElementById(show + label);
    obj.style.display='block';
}

////////////////////////////////////////
/**
 *  FIXME: find a standard library somewhere.
 *
 *  Base64 decode
 *  http://www.webtoolkit.info/
 *
 **/
var Base64 = {
    // private property
    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for decoding
    decode : function (input) {
	    var output = "";
	    var chr1, chr2, chr3;
	    var enc1, enc2, enc3, enc4;
	    var i = 0;

	    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

	    while (i < input.length) {
	        enc1 = this._keyStr.indexOf(input.charAt(i++));
	        enc2 = this._keyStr.indexOf(input.charAt(i++));
	        enc3 = this._keyStr.indexOf(input.charAt(i++));
	        enc4 = this._keyStr.indexOf(input.charAt(i++));

	        chr1 = (enc1 << 2) | (enc2 >> 4);
	        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
	        chr3 = ((enc3 & 3) << 6) | enc4;

	        output = output + String.fromCharCode(chr1);

	        if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
	        }
	        if (enc4 != 64) {
		        output = output + String.fromCharCode(chr3);
	        }
	    }
	    output = Base64._utf8_decode(output);
	    return output;

    },
    // private method for UTF-8 decoding
    _utf8_decode : function (utftext) {
	    var string = "";
	    var i = 0;
	    var c = c1 = c2 = 0;
	    while (i < utftext.length) {
	        c = utftext.charCodeAt(i);

	        if (c < 128) {
				string += String.fromCharCode(c);
				i++;
	        }
	        else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
	        }
	        else {
		        c2 = utftext.charCodeAt(i+1);
		        c3 = utftext.charCodeAt(i+2);
		        string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
		        i += 3;
	        }
	    }
	    return string;
    }
}
